# Generated by Django 3.2.9 on 2023-04-23 16:17

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='RestaurantModel',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('restaurantName', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantPhone', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantContactPerson', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantContactPhone', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantImage', models.ImageField(blank=True, null=True, upload_to='restaurantImage/')),
                ('restaurantAddress', models.CharField(blank=True, max_length=2000, null=True)),
                ('hideStatus', models.IntegerField(default=0)),
                ('createdAt', models.DateTimeField(auto_now_add=True)),
                ('updatedAt', models.DateTimeField(auto_now=True)),
            ],
        ),
        migrations.CreateModel(
            name='UserTypeModel',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('staffTypeName', models.CharField(blank=True, max_length=200, null=True)),
                ('hideStatus', models.IntegerField(default=0)),
                ('createdAt', models.DateTimeField(auto_now_add=True)),
                ('updatedAt', models.DateTimeField(auto_now=True)),
            ],
        ),
        migrations.CreateModel(
            name='UserModel',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('userName', models.CharField(blank=True, max_length=200, null=True)),
                ('userPhone', models.CharField(blank=True, max_length=200, null=True)),
                ('userOTP', models.CharField(blank=True, max_length=200, null=True)),
                ('otpValidate', models.CharField(blank=True, max_length=200, null=True)),
                ('hideStatus', models.IntegerField(default=0)),
                ('createdAt', models.DateTimeField(auto_now_add=True)),
                ('updatedAt', models.DateTimeField(auto_now=True)),
                ('userTypeId', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='apis.usertypemodel')),
            ],
        ),
        migrations.CreateModel(
            name='UserAddressModel',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('restaurantAddress', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantCity', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantState', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantCountry', models.CharField(blank=True, max_length=200, null=True)),
                ('restaurantPincode', models.CharField(blank=True, max_length=200, null=True)),
                ('hideStatus', models.IntegerField(default=0)),
                ('createdAt', models.DateTimeField(auto_now_add=True)),
                ('updatedAt', models.DateTimeField(auto_now=True)),
                ('userId', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='apis.usermodel')),
            ],
        ),
        migrations.CreateModel(
            name='OrderModel',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('orderId', models.CharField(blank=True, max_length=200, null=True)),
                ('subTotalAmount', models.CharField(blank=True, max_length=200, null=True)),
                ('deliveryCharge', models.CharField(blank=True, max_length=200, null=True)),
                ('totalAmount', models.CharField(blank=True, max_length=200, null=True)),
                ('paymentStatus', models.CharField(blank=True, max_length=200, null=True)),
                ('txnId', models.CharField(blank=True, max_length=200, null=True)),
                ('paymentId', models.CharField(blank=True, max_length=200, null=True)),
                ('orderNotes', models.CharField(blank=True, max_length=200, null=True)),
                ('hideStatus', models.IntegerField(default=0)),
                ('createdAt', models.DateTimeField(auto_now_add=True)),
                ('updatedAt', models.DateTimeField(auto_now=True)),
                ('restaurantId', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='apis.restaurantmodel')),
                ('userId', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='apis.usermodel')),
            ],
        ),
        migrations.CreateModel(
            name='CartModel',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('categoryId', models.CharField(blank=True, max_length=200, null=True)),
                ('foodId', models.CharField(blank=True, max_length=200, null=True)),
                ('foodName', models.CharField(blank=True, max_length=200, null=True)),
                ('amount', models.CharField(blank=True, max_length=200, null=True)),
                ('qty', models.CharField(blank=True, max_length=200, null=True)),
                ('totalAmount', models.CharField(blank=True, max_length=200, null=True)),
                ('offlineCartId', models.CharField(blank=True, max_length=200, null=True)),
                ('hideStatus', models.IntegerField(default=0)),
                ('createdAt', models.DateTimeField(auto_now_add=True)),
                ('updatedAt', models.DateTimeField(auto_now=True)),
                ('orderId', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='apis.ordermodel')),
                ('restaurantId', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='apis.restaurantmodel')),
                ('userId', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='apis.usermodel')),
            ],
        ),
    ]
