from django.shortcuts import render
from rest_framework import viewsets, status
from rest_framework.decorators import action
from rest_framework.response import Response
from rest_framework.serializers import Serializer
from .models import *
from .serializers import *
from datetime import date
import json

# Create your views here.
class UserTypeViewSet(viewsets.ModelViewSet):
    queryset = UserTypeModel.objects.filter(hideStatus=0)
    serializer_class = UserTypeModelSerializers

    @action(detail=True, methods=['GET'])
    def listing(self, request, pk=None):
        if request.headers['token'] != "":
            user_type_model = UserTypeModel.objects.filter(hideStatus=0) if pk == "0" else UserTypeModel.objects.filter(hideStatus=0, id=pk)
            serializer = UserTypeModelSerializers(user_type_model, many=True)
            response = {'code': 1, 'data': serializer.data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def processing(self, request, pk=None):
        if request.headers['token'] != "":
            serializer = UserTypeModelSerializers(data=request.data) if pk == "0" else UserTypeModelSerializers(instance=UserTypeModel.objects.get(id=pk), data=request.data)
            if serializer.is_valid():
                serializer.save()
                response = {'code': 1, 'message': "Done Successfully"}
            else:
                response = {'code': 0, 'message': "Unable to Process Request"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def deletion(self, request, pk=None):
        if request.headers['token'] != "":
            UserTypeModel.objects.filter(id=pk).update(hideStatus=1)
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)


# Create your views here.
class UserViewSet(viewsets.ModelViewSet):
    queryset = UserModel.objects.filter(hideStatus=0)
    serializer_class = UserModelSerializers

    @action(detail=True, methods=['GET'])
    def listing(self, request, pk=None):
        if request.headers['token'] != "":
            user_type_model = UserModel.objects.filter(hideStatus=0) if pk == "0" else UserModel.objects.filter(hideStatus=0, id=pk)
            serializer = UserModelSerializers(user_type_model, many=True)
            response = {'code': 1, 'data': serializer.data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def processing(self, request, pk=None):
        if request.headers['token'] != "":
            serializer = UserModelSerializers(data=request.data) if pk == "0" else UserModelSerializers(instance=UserModel.objects.get(id=pk), data=request.data)
            if serializer.is_valid():
                serializer.save()
                response = {'code': 1, 'message': "Done Successfully"}
            else:
                response = {'code': 0, 'message': "Unable to Process Request"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def deletion(self, request, pk=None):
        if request.headers['token'] != "":
            UserModel.objects.filter(id=pk).update(hideStatus=1)
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)


# Create your views here.
class UserAddressViewSet(viewsets.ModelViewSet):
    queryset = UserAddressModel.objects.filter(hideStatus=0)
    serializer_class = UserAddressModelSerializers

    @action(detail=True, methods=['GET'])
    def listing(self, request, pk=None):
        if request.headers['token'] != "":
            user_type_model = UserAddressModel.objects.filter(hideStatus=0) if pk == "0" else UserAddressModel.objects.filter(hideStatus=0, id=pk)
            serializer = UserAddressModelSerializers(user_type_model, many=True)
            response = {'code': 1, 'data': serializer.data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def processing(self, request, pk=None):
        if request.headers['token'] != "":
            serializer = UserAddressModelSerializers(data=request.data) if pk == "0" else UserAddressModelSerializers(instance=UserAddressModel.objects.get(id=pk), data=request.data)
            if serializer.is_valid():
                serializer.save()
                response = {'code': 1, 'message': "Done Successfully"}
            else:
                response = {'code': 0, 'message': "Unable to Process Request"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def deletion(self, request, pk=None):
        if request.headers['token'] != "":
            UserAddressModel.objects.filter(id=pk).update(hideStatus=1)
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)


# Create your views here.
class RestaurantViewSet(viewsets.ModelViewSet):
    queryset = RestaurantModel.objects.filter(hideStatus=0)
    serializer_class = RestaurantModelSerializers

    @action(detail=True, methods=['GET'])
    def listing(self, request, pk=None):
        if request.headers['token'] != "":
            user_type_model = RestaurantModel.objects.filter(hideStatus=0) if pk == "0" else RestaurantModel.objects.filter(hideStatus=0, id=pk)
            serializer = RestaurantModelSerializers(user_type_model, many=True)
            response = {'code': 1, 'data': serializer.data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['GET'])
    def food_listing(self, request, pk=None):
        if request.headers['token'] != "":
            menu_json = open('menu_json.json')
            menu_load = json.load(menu_json)
            response = {'code': 1, 'data': menu_load['storeData'][0], 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def food_listing1(self, request, pk=None):
        if request.headers['token'] != "":
            menu_json = open('menu_json.json')
            menu_load = json.load(menu_json)
            load_data = []
            item_data = []
            store_data = menu_load['storeData'][0]
            for i in store_data['categories']:
                for j in store_data['items']:
                    if j['categoryCode'] == i['categoryCode']:
                        qty = '0'
                        cart_id = 0
                        if pk == 0:
                            if CartModel.objects.filter(hideStatus=0, categoryId=i['categoryCode'], foodId=j['itemCode'], userId=request.data['userId']).count() > 0:
                                cart_data_serializer = CartModelSerializers(CartModel.objects.get(hideStatus=0, categoryId=i['categoryCode'], foodId=j['itemCode'], userId=request.data['userId']), many=False)
                                qty = cart_data_serializer.data['qty']
                                cart_id = cart_data_serializer.data['id']
                        else:
                            if CartModel.objects.filter(hideStatus=0, categoryId=i['categoryCode'], foodId=j['itemCode'], offlineCartId=request.data['userId']).count() > 0:
                                cart_data_serializer = CartModelSerializers(CartModel.objects.get(hideStatus=0, categoryId=i['categoryCode'], foodId=j['itemCode'], offlineCartId=request.data['userId']), many=False)
                                qty = cart_data_serializer.data['qty']
                                cart_id = cart_data_serializer.data['id']
                        item_data.append({
                            'categoryCode': j['categoryCode'],
                            'itemCode': j['itemCode'],
                            'itemName': j['itemName'],
                            'imageURL': j['imageURL'],
                            'description': j['description'],
                            'price': j['price'],
                            'gst': j['gst'],
                            'showroomTakeAwayGST': j['showroomTakeAwayGST'],
                            'cartId': cart_id,
                            'qty': qty,
                        })
                load_data.append({
                    'categoryCode': i['categoryCode'],
                    'categoryName': i['parentCategoryName'],
                    'item_data': item_data,
                })
                item_data = []
            response = {'code': 1, 'data': load_data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def food_listing_search(self, request, pk=None):
        if request.headers['token'] != "":
            menu_json = open('menu_json.json')
            menu_load = json.load(menu_json)
            load_data = []
            item_data = []
            store_data = menu_load['storeData'][0]
            for j in store_data['items']:
                qty = '0'
                cart_id = 0
                if pk == 0:
                    if CartModel.objects.filter(hideStatus=0, categoryId=j['categoryCode'], foodId=j['itemCode'],
                                                userId=request.data['userId']).count() > 0:
                        cart_data_serializer = CartModelSerializers(
                            CartModel.objects.get(hideStatus=0, categoryId=j['categoryCode'], foodId=j['itemCode'],
                                                  userId=request.data['userId']), many=False)
                        qty = cart_data_serializer.data['qty']
                        cart_id = cart_data_serializer.data['id']
                else:
                    if CartModel.objects.filter(hideStatus=0, categoryId=j['categoryCode'], foodId=j['itemCode'],
                                                offlineCartId=request.data['userId']).count() > 0:
                        cart_data_serializer = CartModelSerializers(
                            CartModel.objects.get(hideStatus=0, categoryId=j['categoryCode'], foodId=j['itemCode'],
                                                  offlineCartId=request.data['userId']), many=False)
                        qty = cart_data_serializer.data['qty']
                        cart_id = cart_data_serializer.data['id']
                item_data.append({
                    'categoryCode': j['categoryCode'],
                    'itemCode': j['itemCode'],
                    'itemName': j['itemName'],
                    'imageURL': j['imageURL'],
                    'description': j['description'],
                    'price': j['price'],
                    'gst': j['gst'],
                    'showroomTakeAwayGST': j['showroomTakeAwayGST'],
                    'cartId': cart_id,
                    'qty': qty,
                })
            response = {'code': 1, 'data': item_data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def processing(self, request, pk=None):
        if request.headers['token'] != "":
            serializer = RestaurantModelSerializers(data=request.data) if pk == "0" else RestaurantModelSerializers(instance=RestaurantModel.objects.get(id=pk), data=request.data)
            if serializer.is_valid():
                serializer.save()
                response = {'code': 1, 'message': "Done Successfully"}
            else:
                response = {'code': 0, 'message': "Unable to Process Request"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def deletion(self, request, pk=None):
        if request.headers['token'] != "":
            RestaurantModel.objects.filter(id=pk).update(hideStatus=1)
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)


# Create your views here.
class OrderViewSet(viewsets.ModelViewSet):
    queryset = OrderModel.objects.filter(hideStatus=0)
    serializer_class = OrderModelSerializers

    @action(detail=True, methods=['GET'])
    def listing(self, request, pk=None):
        if request.headers['token'] != "":
            user_type_model = OrderModel.objects.filter(hideStatus=0) if pk == "0" else OrderModel.objects.filter(hideStatus=0, id=pk)
            serializer = OrderModelSerializers(user_type_model, many=True)
            response = {'code': 1, 'data': serializer.data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def processing(self, request, pk=None):
        if request.headers['token'] != "":
            serializer = OrderModelSerializers(data=request.data) if pk == "0" else OrderModelSerializers(instance=OrderModel.objects.get(id=pk), data=request.data)
            if serializer.is_valid():
                serializer.save()
                response = {'code': 1, 'message': "Done Successfully"}
            else:
                response = {'code': 0, 'message': "Unable to Process Request"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def deletion(self, request, pk=None):
        if request.headers['token'] != "":
            OrderModel.objects.filter(id=pk).update(hideStatus=1)
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)


# Create your views here.
class CartViewSet(viewsets.ModelViewSet):
    queryset = CartModel.objects.filter(hideStatus=0)
    serializer_class = CartModelSerializers

    @action(detail=True, methods=['GET'])
    def listing(self, request, pk=None):
        if request.headers['token'] != "":
            user_type_model = CartModel.objects.filter(hideStatus=0) \
                if pk == "0" \
                else CartModel.objects.filter(hideStatus=0, id=pk)
            serializer = CartModelSerializers(user_type_model, many=True)
            response = {'code': 1, 'data': serializer.data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def user_listing(self, request, pk=None):
        if request.headers['token'] != "":
            user_type_model = CartModel.objects.filter(hideStatus=0, offlineCartId=request.data['userId']) \
                if pk == "0" \
                else CartModel.objects.filter(hideStatus=0, userId=request.data['userId'])
            serializer = CartModelSerializers(user_type_model, many=True)
            response = {'code': 1, 'data': serializer.data, 'message': "All List Retried"}
        else:
            response = {'code': 0, 'data': [], 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def processing(self, request, pk=None):
        if request.headers['token'] != "":
            serializer = CartModelSerializers(data=request.data) if pk == "0" else CartModelSerializers(instance=CartModel.objects.get(id=pk), data=request.data)
            if serializer.is_valid():
                serializer.save()
                response = {'code': 1, 'message': "Done Successfully"}
            else:
                response = {'code': 0, 'message': "Unable to Process Request"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def update_cart(self, request, pk=None):
        if request.headers['token'] != "":
            if pk == "0":
                serializers = CartModelSerializers(CartModel.objects.filter(restaurantId=request.data['restaurantId'],
                                                                            categoryId=request.data['categoryId'],
                                                                            offlineCartId=request.data['userId'],
                                                                            foodId=request.data['foodId'])
                                                   .order_by('-id')[:1], many=True)
            else:
                serializers = CartModelSerializers(CartModel.objects.filter(restaurantId=request.data['restaurantId'],
                                                                            categoryId=request.data['categoryId'],
                                                                            userId=request.data['userId'],
                                                                            foodId=request.data['foodId'])
                                                   .order_by('-id')[:1], many=True)
            current_cart_id = serializers.data[0]['id']
            CartModel.objects.filter(id=current_cart_id).update(qty=request.data['qty'], totalAmount=request.data['totalAmount'])
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def delete_cart(self, request, pk=None):
        if request.headers['token'] != "":
            if pk == "0":
                serializers = CartModelSerializers(CartModel.objects.filter(restaurantId=request.data['restaurantId'],
                                                                            categoryId=request.data['categoryId'],
                                                                            offlineCartId=request.data['userId'],
                                                                            foodId=request.data['foodId'])
                                                   .order_by('-id')[:1], many=True)
            else:
                serializers = CartModelSerializers(CartModel.objects.filter(restaurantId=request.data['restaurantId'],
                                                                            categoryId=request.data['categoryId'],
                                                                            userId=request.data['userId'],
                                                                            foodId=request.data['foodId'])
                                                   .order_by('-id')[:1], many=True)
            current_cart_id = serializers.data[0]['id']
            CartModel.objects.filter(id=current_cart_id).update(hideStatus=1)
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def update_cart_id(self, request, pk=None):
        if request.headers['token'] != "":
            CartModel.objects.filter(id=pk).update(qty=request.data['qty'], totalAmount=request.data['totalAmount'])
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)

    @action(detail=True, methods=['POST'])
    def deletion(self, request, pk=None):
        if request.headers['token'] != "":
            CartModel.objects.filter(id=pk).update(hideStatus=1)
            response = {'code': 1, 'message': "Done Successfully"}
        else:
            response = {'code': 0, 'message': "Token is invalid"}
        return Response(response)
